🛑 STOP!

Before you open an issue:

1. Make sure that your issue is a BUG or FEATURE REQUEST.  General usage and troubleshooting questions should be directed to the [forums](https://forums.userfrosting.com), [chat](https://chat.userfrosting.com), or [Stack Overflow](https://stackoverflow.com/questions/tagged/userfrosting). You can also consult our chapter on [common problems](https://learn.userfrosting.com/troubleshooting/common-problems). Issues asking for general support WILL BE CLOSED automatically.
2. Search the forums and current issues, both open and closed, for a similar issue. If the bug is still present but the relevant issue has been closed, you may ask us to reopen the issue. Duplicate issues will be closed automatically.
3. Make sure that you are using the latest stable version of UserFrosting (see the [release history](https://github.com/userfrosting/UserFrosting/releases)). Support for UserFrosting 3.x or earlier may be limited.

If you are CERTAIN that it is appropriate to open a new issue, you must:

1. Format any code snippets or command-line output using Markdown [code fences](https://help.github.com/articles/creating-and-highlighting-code-blocks/), and make sure your code is properly indented. **This is extremely important** - poorly formatted code is difficult to read and reflects badly on you as a programmer.
2. Remember that courtesy and proper grammar go a long way. Please take the time to craft a precise, polite issue. We will do our best to help, but remember that this is an open-source project - none of us are getting paid a salary to develop this project, or act as your personal support hotline ;-)
    1. State the steps needed to reproduce the problem.
    2. Mention your version of UserFrosting, as well as the browser(s) and operating system(s) in which the problem occurs.
    3. Report any errors in detail. Vague issues like "it doesn't work when I do this" are not helpful. Show that you have put some effort into identifying the cause of the error. See the section on [debugging](https://learn.userfrosting.com/troubleshooting/debugging) for information on how to get more details about errors and other problems.
3. You should always test your code in a local development environment, to separate code-related issues from server issues. In general, we recommend that you install a local development server on your computer, rather than testing your code directly on the production server. This means you can test your code directly on your own computer, making development faster and without the risk of exposing sensitive information to the public. We recommend installing Vagrant and Homestead if you don't already have a local server set up.
4. If you are not conversationally proficient in English, do NOT just post a machine translation (e.g. Google Translate) to GitHub. Get help in crafting your question, either via the [forums](https://forums.userfrosting.com) or in [chat](https://chat.userfrosting.com). If all else fails, you may post your bug report or feature request in your native language, with a machine translation below that. We will tag it with `translation-needed` so that others who speak your language can find it.
5. Clear out this placeholder text.
6. Consider supporting this project by [making a donation to our Open Collective](https://opencollective.com/userfrosting/donate)!
